#include <iostream>
#include <memory>

template <typename T>
class MyContainer {
	size_t size_;
	std::unique_ptr<T[]> array_;

public:
	explicit MyContainer(size_t s)
	    : size_(s)
	    , array_(std::make_unique<T[]>(size_)) {}

	size_t size() const { return size_; }

	const T& operator[](size_t index) const { return array_[index]; }
	T& operator[](size_t index) { return array_[index]; }
};

int main() {
	MyContainer<double> cont(10);
	for (size_t i = 0; i < cont.size(); ++i) {
		cont[i] = i;
	}
	for (size_t i = 0; i < cont.size(); ++i) {
		std::cout << cont[i] << ' ';
	}
}
